/*
 * @Author: your name
 * @Date: 2021-08-15 11:27:02
 * @LastEditTime: 2022-03-09 05:57:18
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 *
 */
#pragma once

#include "string.h"
#include <future>

using namespace std;
namespace BA {

template <class T> class RosRecv {
public:
  RosRecv(const string &topic) : topic_(topic) {}
  ~RosRecv() {}

  void Callback(const T &msg) {
    std::lock_guard<std::mutex> lock(data_mutex_);
    data_ = msg;
    // cout<<"topic : "<<topic_<<endl;
  }
  std::string topic_;
  T data_;
  std::mutex data_mutex_;
};
} // namespace BA